"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const process = __importStar(require("process"));
const utils_1 = require("@sweet-milktea/utils");
const defaultPlugins_js_1 = __importDefault(require("./utils/defaultPlugins.js"));
const presetEnv_js_1 = __importDefault(require("./utils/presetEnv.js"));
const transformRuntime_js_1 = __importDefault(require("./utils/transformRuntime.js"));
const isDevelopment = process.env.NODE_ENV === 'development';
function babelPresetSweet(api, options = {}, dirname) {
    const { env, typescript, react, polyfill } = options;
    const { nodeEnv, ecmascript, targets: customTargets, debug, modules, useBuiltIns } = env ?? {}, { use: useTypescript, isReact = true } = typescript ?? {}, { use: useReact = true, runtime, development } = react ?? {};
    const envModules = modules ?? false; // @babel/preset-env的模块类型
    // 编译目标
    let babelBuildTargets;
    if (customTargets) {
        babelBuildTargets = customTargets;
    }
    else {
        if (ecmascript) {
            babelBuildTargets = {
                browsers: nodeEnv ? ['node 14'] : ['last 5 Chrome versions']
            };
        }
        else {
            babelBuildTargets = {
                browsers: nodeEnv ? ['node 10'] : [
                    'last 10 versions',
                    'last 2 year',
                    'Edge 16'
                ]
            };
        }
    }
    const presets = [];
    const plugins = defaultPlugins_js_1.default.concat([
        (0, transformRuntime_js_1.default)({
            ecmascript,
            nodeEnv,
            polyfill
        })
    ]);
    // 添加@babel/preset-env
    presets.push((0, presetEnv_js_1.default)({
        babelBuildTargets,
        useBuiltIns,
        debug,
        envModules,
        polyfill
    }));
    // 添加@babel/preset-react
    if (useReact) {
        presets.push([
            '@babel/preset-react',
            {
                runtime: runtime ?? ((0, utils_1.moduleExists)('react/jsx-runtime') ? 'automatic' : 'classic'),
                development: development ?? isDevelopment
            }
        ]);
    }
    // 添加@babel/preset-typescript
    if (useTypescript) {
        presets.push([
            '@babel/preset-typescript',
            {
                isTSX: true,
                jsxPragma: isReact ? 'React' : 'Preserve',
                allExtensions: true,
                allowNamespaces: true
            }
        ]);
    }
    // 添加babel-plugin-polyfill-{name}相关插件
    if (polyfill) {
        plugins.push([
            'babel-plugin-polyfill-corejs3',
            {
                method: 'usage-global',
                targets: babelBuildTargets
            }
        ], [
            'babel-plugin-polyfill-es-shims',
            {
                method: 'usage-global',
                targets: babelBuildTargets
            }
        ]);
    }
    return { presets, plugins };
}
exports.default = babelPresetSweet;
